SystemOrganization addCategory: #'KwisatzHaderach-StackListener'!
SystemOrganization addCategory: #KwisatzHaderach!
SystemOrganization addCategory: #'KwisatzHaderach-Tests'!
SystemOrganization addCategory: #'KwisatzHaderach-GraphNodes'!
SystemOrganization addCategory: #'KwisatzHaderach-Visitor'!

Object subclass: #ChainListExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!ChainListExpression class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:59'!
chainMessage 
	^self new chainMessage.! !

!ChainListExpression methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:58'!
anOtherChainMessage
	self anOtherOtherChainMessage .! !

!ChainListExpression methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:58'!
anOtherOtherChainMessage
	^1.! !

!ChainListExpression methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:57'!
chainMessage
	self anOtherChainMessage.! !

Object subclass: #CommonExpressions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!CommonExpressions class methodsFor: 'arithmetic' stamp: 'SantiagoBragagnolo 6/5/2012 23:14'!
commonAdd
	| a b |
	a:= 1.
	b:=2.
	a := a + b.
	^a ! !

Object subclass: #KHClass
	instanceVariableNames: 'representedClass possibleInstances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-GraphNodes'!

!KHClass class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/7/2012 21:34'!
for: aClass
	| instance | 
	instance := self new.
	instance useClass: aClass.
	^instance.
	! !

!KHClass methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 13:47'!
accept: aKHVisitor
	aKHVisitor visitClass: self.! !

!KHClass methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 6/9/2012 21:25'!
initialize 	
	super initialize.
	possibleInstances  := Dictionary new.! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 21:26'!
invocatedMethods
	^self invocatedSelectors collect: [ :selector | 
		self resolveMethodFor: selector.
	].! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 21:40'!
invocatedSelectors
	| resultSet sels | 
	
	self isRoot ifTrue: [ ^Set new ].
	sels := self possibleInstancesCollect:#allSelectorSymbols.
	resultSet := sels inject: Set new into: [ :result :selectors | result addAll: selectors. ].
	^resultSet.
	! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 21:24'!
isRoot
	^representedClass = KHRootNode.! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 20:58'!
possibleInstancesCollect: aBlock
	^possibleInstances values collect: aBlock.! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 20:52'!
possibleInstancesDo: aBlock
	^possibleInstances values do:aBlock.! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:56'!
representationOf: anObjectType 
	^possibleInstances at: anObjectType ifAbsentPut: [ KHClassConfiguration for: anObjectType of: self].! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 14:22'!
representedClass
	^representedClass 
	! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 21:31'!
resolveMethodFor: aSelector

	^self resolveMethodFor: aSelector beginWith: self representedClass.
	
	! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 21:32'!
resolveMethodFor: aSelector beginWith: aClass
	aClass ifNil: [
		self error: aClass name, ' does not understand ', aSelector.
	].
	^aClass methodDict at: aSelector ifAbsent:[ self resolveMethodFor: aSelector beginWith: aClass superclass ] .
	
	
	! !

!KHClass methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:34'!
useClass: aClass
	representedClass := aClass
	! !

Object subclass: #KHClassConfiguration
	instanceVariableNames: 'configuration instanceOf selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-GraphNodes'!

!KHClassConfiguration class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/7/2012 21:39'!
for: anObjectType of: aKHClass
	| instance |
	instance := self new.
	instance configuration: anObjectType.
	instance instanceOf: aKHClass.
	^ instance.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:52'!
accept: aKHVisitor
	aKHVisitor visitClassConfiguration: self.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 20:54'!
allSelectorSymbols
	^ self allSelectors collect:#selector.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 20:53'!
allSelectors
	^ selectors values.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:49'!
atSelectorComposedBy:anOriginSelector withArguments: anOriginalSelectorArgumentsArray.

	^selectors 	at: (KHSelector makeUniqueIdentifier: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: self) 
				ifAbsentPut: [ KHSelector for: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: self ]. ! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:38'!
configuration: anObjectType 
	configuration := anObjectType.! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 12:51'!
hash
	^configuration hash.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
initialize 
	super initialize.
	selectors  := Dictionary new.
	! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 14:22'!
instanceOf
	^instanceOf.! !

!KHClassConfiguration methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:38'!
instanceOf: aKHClass 
	instanceOf := aKHClass.! !

!KHClassConfiguration methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 15:02'!
selectors
	^selectors! !

Object subclass: #KHRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-GraphNodes'!

!KHRootNode methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 21:23'!
rootMessage
	^self. ! !

Object subclass: #KHSelector
	instanceVariableNames: 'uid selector arguments owner callsIn callsOut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-GraphNodes'!

!KHSelector class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 12:50'!
for: aSelector withArguments: anArgumentsArray at: aKHClassConfiguration 
	| instance | 
	instance := self new.
	instance uid: (self makeUniqueIdentifier: aSelector withArguments: anArgumentsArray at: aKHClassConfiguration  ).
	instance selector: aSelector.
	instance arguments: anArgumentsArray.
	instance owner: aKHClassConfiguration.
	^instance.! !

!KHSelector class methodsFor: 'auxiliar' stamp: 'SantiagoBragagnolo 6/9/2012 12:50'!
makeUniqueIdentifier: anOriginSelector withArguments: anOriginalSelectorArgumentsArray at: aKHClassConfiguration

	| uq arguments |
	
	arguments := '' join: (anOriginalSelectorArgumentsArray collect: [ :t | t hash asString ]).
	uq := aKHClassConfiguration hash asString, anOriginSelector, arguments.
	
	^uq.! !

!KHSelector methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:52'!
accept: aKHVisitor
	aKHVisitor visitSelector: self.! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:57'!
arguments: anArgumentsArray.
	arguments := anArgumentsArray.! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/9/2012 14:27'!
callIn: idx
	idx > callsIn size ifTrue: [ ^nil ].
	^callsIn at:idx.! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/9/2012 14:26'!
callOut: idx
	idx > callsOut size ifTrue: [ ^nil ].
	^callsOut at:idx.! !

!KHSelector methodsFor: 'calls' stamp: 'SantiagoBragagnolo 6/7/2012 22:01'!
callsTo: methodCalled
	self registerCallTo: methodCalled.
	methodCalled registerCalledBy: self.
	! !

!KHSelector methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 6/7/2012 21:58'!
initialize 
	callsIn := OrderedCollection new. 
	callsOut := OrderedCollection new.
	! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 14:22'!
khclass
	^owner instanceOf.! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:57'!
owner: aConfiguration
	owner := aConfiguration.! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/7/2012 21:59'!
registerCallTo: aTargetCall
	callsOut add: aTargetCall.
	
	! !

!KHSelector methodsFor: 'private tier' stamp: 'SantiagoBragagnolo 6/7/2012 22:00'!
registerCalledBy: asTargetedBy
	callsIn add: asTargetedBy.
	
	! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 14:53'!
selector
	^ selector! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 20:30'!
selector: aSelector.
	selector := aSelector.! !

!KHSelector methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:56'!
uid: anUid
	uid := anUid.
! !

Object subclass: #KHVisitor
	uses: TLogger
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Visitor'!

KHVisitor class
	uses: TLogger classTrait
	instanceVariableNames: ''!

KHVisitor subclass: #KHExecutionPathVisitor
	instanceVariableNames: 'selectorInvocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Visitor'!

!KHExecutionPathVisitor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:51'!
beginWith: aRootMessage
	|instance| 
	instance := self new.
	aRootMessage accept: instance.
	^instance. ! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:23'!
initialize 
	selectorInvocations := Dictionary new.
	path := ''.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:33'!
nextSelector: aKHSelector
	| callOut callIn next invocations |
	invocations := selectorInvocations at:aKHSelector ifAbsent:[ {1 . 1} ].
	callOut := invocations at:1.
	callIn := invocations at:2.
	
	" #(1 1) callOut callIn "
	
	next := aKHSelector callOut: callOut.
	callOut := callOut +1 .
	
	next ifNil: [
		next := aKHSelector callIn: callIn.
		callIn := callIn + 1.
	] .
	
	selectorInvocations at:aKHSelector put: { callOut . callIn}.
	
	^next.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:40'!
path
	^path.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:53'!
pushPath: aKHSelector
	path := path , '#', aKHSelector khclass representedClass name, '>>', aKHSelector selector, ' >>= ', Character cr asString.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:40'!
visitClass: aKHClass
	
	self error: 'Execution path visitor must not visit classes, just selectors'.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:14'!
visitClassConfiguration: aKHClassConfiguration
	self error: 'Execution path visitor must not visit classes configuration, just selectors'.! !

!KHExecutionPathVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:37'!
visitSelector: aKHSelector
 | next |
	self debug: [ 'visiting'].

	self pushPath: aKHSelector. 
	next := self nextSelector: aKHSelector.
	
	next ifNotNil: [
		next accept: self.
	] ifNil:[
		self debug: [ 'end of graph'].
	].
	! !

!KHVisitor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:38'!
configurationOfLog
	! !

!KHVisitor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:45'!
configurationOfLog:builder
	<logConfiguration>
	^   builder forClass: self
			     useLevel:#debug
			     showingLogAs: ('%pih | %tstmp | %tag #%class >> %selector [%log]' asPatternFormatter) 
			     into: Transcript asLogWriter .! !

!KHVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:14'!
visitClass: aKHClass! !

!KHVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:14'!
visitClassConfiguration: aKHClassConfiguration! !

!KHVisitor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:14'!
visitSelector: aKHSelector
	
	! !

Object subclass: #KwisatzHaderach
	uses: TLogger
	instanceVariableNames: 'result stackListener rootSender classes rootMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach'!

KwisatzHaderach class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!KwisatzHaderach class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 6/9/2012 11:54'!
callgraphFor: anExpression
	| instance | 
	instance := self new.
	^instance callgraphFor: anExpression
	! !

!KwisatzHaderach class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:44'!
configurationOfLog
	^self.! !

!KwisatzHaderach class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:45'!
configurationOfLog:builder
	<logConfiguration>
	^   builder forClass: self
			     useLevel:#debug
			     showingLogAs: ('%pih | %tstmp | %tag #%class >> %selector [%log]' asPatternFormatter) 
			     into: Transcript asLogWriter.! !

!KwisatzHaderach methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 21:39'!
allClasses 
	^classes values.! !

!KwisatzHaderach methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 21:50'!
asMethodsToExecuteSet
	| kh |
	kh := Set new.
	self allClasses do: [ :aKHClass | kh addAll: aKHClass invocatedMethods asSet.  ].
	^kh
! !

!KwisatzHaderach methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:47'!
asPathExecution
	^KHExecutionPathVisitor beginWith: rootMessage.! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/5/2012 23:17'!
callgraphFor: anExpression
	result := Compiler new analyze: anExpression  in:  nil to: nil notifying: nil ifFail:[ :fail | self manage: fail].
	^ self.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
initialize 
	super initialize.
	TiPrimitive initialize.
	TiSystem current reset.
	stackListener := StackListener for: self.
	classes := Dictionary new.
	self registerToStackAnnouncements.
	
! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 21:11'!
makeRootMethodSender
	rootMessage ifNil: [
		rootMessage := self makeRootSender atSelectorComposedBy: 'rootMessage' withArguments: #().
		
	]ifNotNil: [
		self warn: ' rootMessage obtained more than once!! '.
	].

	^rootMessage.
! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 21:37'!
makeRootSender
	rootSender ifNil: [ 
		rootSender := self representationOf: (KHRootNode new concreteType).
	] ifNotNil:[
		self warn: ' rootSender obtained more than once!! '.
	].
	^rootSender

	
! !

!KwisatzHaderach methodsFor: 'error' stamp: 'SantiagoBragagnolo 6/5/2012 22:46'!
manage: fail
	self error: fail.! !

!KwisatzHaderach methodsFor: 'callgraph' stamp: 'SantiagoBragagnolo 6/9/2012 12:27'!
register: aSelector withArguments: anArgumentsArray sentTo: aReceptorObjectType  from: anOriginSelector withArguments: anOriginalSelectorArgumentsArray atSender: aSenderObjectType
	| objectSender objectReceptor methodSender methodCalled senderArgumentsArray | 

	(aSenderObjectType = nil) ifFalse:[
		objectSender  := self representationOf: aSenderObjectType.
		methodSender := objectSender atSelectorComposedBy:anOriginSelector withArguments: anOriginalSelectorArgumentsArray.
	] ifTrue: [
		objectSender := self makeRootSender.
		methodSender := self makeRootMethodSender.
	].
	
	objectReceptor  := self representationOf: aReceptorObjectType.
	methodCalled := objectReceptor atSelectorComposedBy: aSelector withArguments: anArgumentsArray.
	
	methodSender callsTo: methodCalled.! !

!KwisatzHaderach methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/9/2012 12:24'!
registerToStackAnnouncements
	TiSystem current interpreter subscribe: StackPoped send:#announcePop: to: self stackListener.
	TiSystem current interpreter subscribe: StackPushed send:#announcePush: to: self stackListener.! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/7/2012 21:32'!
representationOf: anObjectType 
	| class |
	class := self representationOfClass: anObjectType exactClass.
	^class representationOf: anObjectType ! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/9/2012 12:32'!
representationOfClass: aClass
	^classes at: aClass  ifAbsentPut: [ KHClass for: aClass ].! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener 
	^stackListener ! !

!KwisatzHaderach methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:15'!
stackListener: aListener
	stackListener := aListener.! !

Object subclass: #KwisatzHaderachWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-Tests'!

!KwisatzHaderachWorkspace methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 15:09'!
callgraphChainMessage
" self new callgraphChainMessage asMethodsToExecuteSet	 "
	^KwisatzHaderach callgraphFor: 'ChainListExpression chainMessage'.! !

!KwisatzHaderachWorkspace methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/9/2012 14:59'!
callgraphCommonAdd
" self new callgraphCommonAdd asPathExecution"
	^KwisatzHaderach callgraphFor: 'CommonExpressions commonAdd'.! !

Object subclass: #StackListener
	uses: TLogger
	instanceVariableNames: 'classMap selectorMap methodMap owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KwisatzHaderach-StackListener'!

StackListener class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!StackListener class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/5/2012 23:18'!
for: aKwisatzHaderach 
	| instance | 
	instance := self new.
	instance owner: aKwisatzHaderach.
	^instance. ! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/9/2012 12:26'!
announcePop: aStackPoped 
	self info:[ 'pop announced' ].! !

!StackListener methodsFor: 'announcement' stamp: 'SantiagoBragagnolo 6/9/2012 12:27'!
announcePush: aStackPushed
| anObjectType|
	anObjectType := aStackPushed receptor veryDeepCopyWithContext: ContextualDeepCopier kwisatzHaderach.
	self info:[ 'push announced' ].
	owner 	register: aStackPushed selector 
			withArguments: aStackPushed arguments 
			sentTo: anObjectType 
			from:aStackPushed senderSelector 
			withArguments: aStackPushed senderArguments  
			atSender: aStackPushed sender.
! !

!StackListener methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 6/5/2012 22:23'!
initialize
	classMap := Dictionary new.
	selectorMap := Dictionary new.
	methodMap := Dictionary new.! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner
 	^owner! !

!StackListener methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 6/5/2012 23:19'!
owner: aKwisatzHaderach 	
 	owner := aKwisatzHaderach.! !
